#pragma once
#include "common.h"
#include "EditForm.h"

class CMainFrame : public CFrameWindowImpl<CMainFrame>,public CMessageFilter
{
protected:
	CFormView m_view;
public:
	DECLARE_FRAME_WND_CLASS(NULL, IDR_MAINFRAME)

	virtual BOOL PreTranslateMessage(MSG* pMsg){
		if(CFrameWindowImpl<CMainFrame>::PreTranslateMessage(pMsg))
			return TRUE;

		return m_view.PreTranslateMessage(pMsg);
	}

	BEGIN_MSG_MAP_EX(CMainFrame)
		MSG_WM_CREATE(OnCreate)
		CHAIN_MSG_MAP(CFrameWindowImpl<CMainFrame>)
		CHAIN_CLIENT_COMMANDS()	// r[NXփR}h`F[
	END_MSG_MAP()

	LRESULT OnCreate(LPCREATESTRUCT lpcs){
		// r[쐬
		m_hWndClient = m_view.Create(m_hWnd);

		//EBhETCYύX
		CRect Rect;
		m_view.GetWindowRect(Rect);
		AdjustWindowRect(Rect,GetWindowLong(GWL_STYLE),true);

		CRect CurrentRect;
		GetWindowRect(CurrentRect);
		MoveWindow(CurrentRect.left,CurrentRect.top,Rect.Width(),Rect.Height());

		// bZ[W[vɃbZ[WtB^ƃAChnhǉ
		CMessageLoop* pLoop = _Module.GetMessageLoop();
		pLoop->AddMessageFilter(this);

		return 0;
	}

};
