/////////////////////////////////////////////////////////////////////////////
//
// Last update	$Date: 2007/11/11 13:13:45 $ UTC
//   Revision   $Revision: 1.25 $
//
//	Modified by Claybird <claybird.without.wing@gmail.com>
//
// MenuExtension.h :gVF ReNXgj[R|[lgNX̃wb_
//					LhaForgegj[
//
//	Original File Information:
// MenuExtension.h :gVF ReNXgj[R|[lgNX̃wb_
//					l(TF)gj[
//
/////////////////////////////////////////////////////////////////////////////

#pragma once

#include "ConfigManager.h"

const int PARAM_MAX_LEN=256;

class MenuListItem{
public:
	CString	MenuCaption;	// j[e
	CString	Param;			// R}hCp^
};

//CPT:m_CmdParamTblP
//PARAM:LZH,ZIP,etc.
#define EXTRA_MENU_ADD_CMD_TBL(CPT,PARAM) \
{\
	for(UINT iIndex=1;iIndex<sizeof(ExtraMenu##PARAM)/sizeof(SHELL_MENU_ITEM);iIndex++){\
		MenuListItem mli;\
		mli.Param = ExtraMenu##PARAM[iIndex].Param;\
		CPT.push_back(mli);\
	}\
}

//CSM=s_hCompressSubMenu
//CPI=CmdParamIndex
//ESMI=ExtraSubMenuIndex
//ICF=m_IdCmdFirst
//ESML=ExtraSubMenuList
//PARAM:LZH,ZIP,etc.
#define EXTRA_MENU_ADD_MENU(CSM,CPI,ESMI,ICF,ESML,PARAM) \
{\
	HMENU hTempMenu=::CreatePopupMenu();\
	TCHAR temp[256];\
	::LoadString(g_hInstDLL,ExtraMenu##PARAM[0].Caption,temp,255);\
	UtilInsertMenuItem(CSM, temp,ESMI,hTempMenu, ICF+nPopupMenuID/*0*//*ICF+CPI*/);\
	/*CPI++;*/nPopupMenuID++;\
	ESMI++;\
	for(int i=1;i<sizeof(ExtraMenu##PARAM)/sizeof(SHELL_MENU_ITEM);i++){\
		::LoadString(g_hInstDLL,ExtraMenu##PARAM[i].Caption,temp,255);\
		UtilInsertMenuItem(hTempMenu,temp, i-1,NULL,ICF + CPI);\
		CPI++;\
	}\
	ESML.push_back(hTempMenu);\
}

// ReNXgj[R|[lg̍쐬iIShellExtInit,IContextMenu𑽏dpj
class CMenuExtension : public IShellExtInit,
						public IContextMenu
{
protected:
	bool			m_bXP;					//WindowsXP͂ȍ~Ȃtrue
	LONG			m_cRef;					// IuWFNg̎QƃJEg
	LPDATAOBJECT	m_DataObjP;				// GNXv[󂯎f[^IuWFNg

	std::vector<CString> m_SelFileArray;	// It@Ce[u

	std::vector<MenuListItem> m_CmdParamArray;// j[LvVƃR}hp[^̃e[u
	UINT			m_nUserMenuCount;		//[U[`̃j[̐

	void			PrepareMenu();			// j[̏
	STDMETHODIMP	GetFileNames();			// It@Co
	void			DeleteFileData();		// It@Ce[uGA̔j
	void			DeleteMenuData();		// j[f[^̔j
	void			DoCommand(UINT inIdx);	// Igj[̃R}hs

	UINT			m_nCompressMenuCount;	//kj[̃ACe

	CConfigManager	ConfigManager;
	bool			m_bRightDrag;				//EhbOǂ;CLSIDŕނAClassFactoryŌ܂
	bool			m_bForceExtraMenu;			//gj[(SHIFT+ENbN/hbO)ǂ
	std::list<HMENU>	m_MenuHandleList;		//|bvAbvj[̃nhǗ

	CString			m_strTargetFolder;			//hbÕtH_

	UINT InsertContextMenu(HMENU hMenu,UINT &indexMenu,UINT idCmdFirst,BOOL bInSubMenu);	//j[ǉ
public:
	// RXgN^EfXgN^
	CMenuExtension(bool);
	virtual ~CMenuExtension();

	// IUnknown C^[tFCX̃\bh
	STDMETHODIMP            QueryInterface(REFIID, LPVOID *);
	STDMETHODIMP_(ULONG)    AddRef();
	STDMETHODIMP_(ULONG)    Release();

	// IShellExtInit C^[tFCX̃\bh
	STDMETHODIMP Initialize(LPCITEMIDLIST pIDFolder, LPDATAOBJECT pDataObj, HKEY hKeyID);

	// IContextMenu C^[tFCX̃\bh
	STDMETHODIMP QueryContextMenu(HMENU hMenu, UINT indexMenu, UINT idCmdFirst,UINT idCmdLast, UINT uFlags);
	STDMETHODIMP InvokeCommand(LPCMINVOKECOMMANDINFO lpcmi);
	STDMETHODIMP GetCommandString(UINT_PTR idCmd, UINT uType, UINT* pwReserved,LPSTR pszName, UINT cchMax);
};
// |C^^錾
typedef CMenuExtension *LPCMENUEXTENSION;


